# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities
from . import outputs
from ._inputs import *

__all__ = ['ActiveActiveSubscriptionArgs', 'ActiveActiveSubscription']

@pulumi.input_type
class ActiveActiveSubscriptionArgs:
    def __init__(__self__, *,
                 cloud_provider: Optional[pulumi.Input[str]] = None,
                 creation_plan: Optional[pulumi.Input['ActiveActiveSubscriptionCreationPlanArgs']] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 payment_method: Optional[pulumi.Input[str]] = None,
                 payment_method_id: Optional[pulumi.Input[str]] = None):
        """
        The set of arguments for constructing a ActiveActiveSubscription resource.
        :param pulumi.Input[str] cloud_provider: The cloud provider to use with the subscription, (either `AWS` or `GCP`). Default: ‘AWS’
        :param pulumi.Input['ActiveActiveSubscriptionCreationPlanArgs'] creation_plan: A creation plan object, documented below
        :param pulumi.Input[str] name: A meaningful name to identify the subscription
        :param pulumi.Input[str] payment_method: The payment method for the requested subscription, (either `credit-card` or `marketplace`). If `credit-card` is specified, `payment_method_id` must be defined. Default: 'credit-card'
        :param pulumi.Input[str] payment_method_id: A valid payment method pre-defined in the current account. This value is __Optional__ for AWS/GCP Marketplace accounts, but __Required__ for all other account types
        """
        if cloud_provider is not None:
            pulumi.set(__self__, "cloud_provider", cloud_provider)
        if creation_plan is not None:
            pulumi.set(__self__, "creation_plan", creation_plan)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if payment_method is not None:
            pulumi.set(__self__, "payment_method", payment_method)
        if payment_method_id is not None:
            pulumi.set(__self__, "payment_method_id", payment_method_id)

    @property
    @pulumi.getter(name="cloudProvider")
    def cloud_provider(self) -> Optional[pulumi.Input[str]]:
        """
        The cloud provider to use with the subscription, (either `AWS` or `GCP`). Default: ‘AWS’
        """
        return pulumi.get(self, "cloud_provider")

    @cloud_provider.setter
    def cloud_provider(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "cloud_provider", value)

    @property
    @pulumi.getter(name="creationPlan")
    def creation_plan(self) -> Optional[pulumi.Input['ActiveActiveSubscriptionCreationPlanArgs']]:
        """
        A creation plan object, documented below
        """
        return pulumi.get(self, "creation_plan")

    @creation_plan.setter
    def creation_plan(self, value: Optional[pulumi.Input['ActiveActiveSubscriptionCreationPlanArgs']]):
        pulumi.set(self, "creation_plan", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        A meaningful name to identify the subscription
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter(name="paymentMethod")
    def payment_method(self) -> Optional[pulumi.Input[str]]:
        """
        The payment method for the requested subscription, (either `credit-card` or `marketplace`). If `credit-card` is specified, `payment_method_id` must be defined. Default: 'credit-card'
        """
        return pulumi.get(self, "payment_method")

    @payment_method.setter
    def payment_method(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "payment_method", value)

    @property
    @pulumi.getter(name="paymentMethodId")
    def payment_method_id(self) -> Optional[pulumi.Input[str]]:
        """
        A valid payment method pre-defined in the current account. This value is __Optional__ for AWS/GCP Marketplace accounts, but __Required__ for all other account types
        """
        return pulumi.get(self, "payment_method_id")

    @payment_method_id.setter
    def payment_method_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "payment_method_id", value)


@pulumi.input_type
class _ActiveActiveSubscriptionState:
    def __init__(__self__, *,
                 cloud_provider: Optional[pulumi.Input[str]] = None,
                 creation_plan: Optional[pulumi.Input['ActiveActiveSubscriptionCreationPlanArgs']] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 payment_method: Optional[pulumi.Input[str]] = None,
                 payment_method_id: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering ActiveActiveSubscription resources.
        :param pulumi.Input[str] cloud_provider: The cloud provider to use with the subscription, (either `AWS` or `GCP`). Default: ‘AWS’
        :param pulumi.Input['ActiveActiveSubscriptionCreationPlanArgs'] creation_plan: A creation plan object, documented below
        :param pulumi.Input[str] name: A meaningful name to identify the subscription
        :param pulumi.Input[str] payment_method: The payment method for the requested subscription, (either `credit-card` or `marketplace`). If `credit-card` is specified, `payment_method_id` must be defined. Default: 'credit-card'
        :param pulumi.Input[str] payment_method_id: A valid payment method pre-defined in the current account. This value is __Optional__ for AWS/GCP Marketplace accounts, but __Required__ for all other account types
        """
        if cloud_provider is not None:
            pulumi.set(__self__, "cloud_provider", cloud_provider)
        if creation_plan is not None:
            pulumi.set(__self__, "creation_plan", creation_plan)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if payment_method is not None:
            pulumi.set(__self__, "payment_method", payment_method)
        if payment_method_id is not None:
            pulumi.set(__self__, "payment_method_id", payment_method_id)

    @property
    @pulumi.getter(name="cloudProvider")
    def cloud_provider(self) -> Optional[pulumi.Input[str]]:
        """
        The cloud provider to use with the subscription, (either `AWS` or `GCP`). Default: ‘AWS’
        """
        return pulumi.get(self, "cloud_provider")

    @cloud_provider.setter
    def cloud_provider(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "cloud_provider", value)

    @property
    @pulumi.getter(name="creationPlan")
    def creation_plan(self) -> Optional[pulumi.Input['ActiveActiveSubscriptionCreationPlanArgs']]:
        """
        A creation plan object, documented below
        """
        return pulumi.get(self, "creation_plan")

    @creation_plan.setter
    def creation_plan(self, value: Optional[pulumi.Input['ActiveActiveSubscriptionCreationPlanArgs']]):
        pulumi.set(self, "creation_plan", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        A meaningful name to identify the subscription
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter(name="paymentMethod")
    def payment_method(self) -> Optional[pulumi.Input[str]]:
        """
        The payment method for the requested subscription, (either `credit-card` or `marketplace`). If `credit-card` is specified, `payment_method_id` must be defined. Default: 'credit-card'
        """
        return pulumi.get(self, "payment_method")

    @payment_method.setter
    def payment_method(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "payment_method", value)

    @property
    @pulumi.getter(name="paymentMethodId")
    def payment_method_id(self) -> Optional[pulumi.Input[str]]:
        """
        A valid payment method pre-defined in the current account. This value is __Optional__ for AWS/GCP Marketplace accounts, but __Required__ for all other account types
        """
        return pulumi.get(self, "payment_method_id")

    @payment_method_id.setter
    def payment_method_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "payment_method_id", value)


class ActiveActiveSubscription(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 cloud_provider: Optional[pulumi.Input[str]] = None,
                 creation_plan: Optional[pulumi.Input[pulumi.InputType['ActiveActiveSubscriptionCreationPlanArgs']]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 payment_method: Optional[pulumi.Input[str]] = None,
                 payment_method_id: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        ## Example Usage

        ```python
        import pulumi
        import pulumi_rediscloud as rediscloud

        card = rediscloud.get_payment_method(card_type="Visa")
        subscription_resource = rediscloud.ActiveActiveSubscription("subscription-resource",
            payment_method_id=card.id,
            cloud_provider="AWS",
            creation_plan=rediscloud.ActiveActiveSubscriptionCreationPlanArgs(
                memory_limit_in_gb=1,
                quantity=1,
                regions=[
                    rediscloud.ActiveActiveSubscriptionCreationPlanRegionArgs(
                        region="us-east-1",
                        networking_deployment_cidr="192.168.0.0/24",
                        write_operations_per_second=1000,
                        read_operations_per_second=1000,
                    ),
                    rediscloud.ActiveActiveSubscriptionCreationPlanRegionArgs(
                        region="us-east-2",
                        networking_deployment_cidr="10.0.1.0/24",
                        write_operations_per_second=1000,
                        read_operations_per_second=1000,
                    ),
                ],
            ))
        ```

        ## Import

        `rediscloud_active_active_subscription` can be imported using the ID of the subscription, e.g.

        ```sh
         $ pulumi import rediscloud:index/activeActiveSubscription:ActiveActiveSubscription subscription-resource 12345678
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] cloud_provider: The cloud provider to use with the subscription, (either `AWS` or `GCP`). Default: ‘AWS’
        :param pulumi.Input[pulumi.InputType['ActiveActiveSubscriptionCreationPlanArgs']] creation_plan: A creation plan object, documented below
        :param pulumi.Input[str] name: A meaningful name to identify the subscription
        :param pulumi.Input[str] payment_method: The payment method for the requested subscription, (either `credit-card` or `marketplace`). If `credit-card` is specified, `payment_method_id` must be defined. Default: 'credit-card'
        :param pulumi.Input[str] payment_method_id: A valid payment method pre-defined in the current account. This value is __Optional__ for AWS/GCP Marketplace accounts, but __Required__ for all other account types
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: Optional[ActiveActiveSubscriptionArgs] = None,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        ## Example Usage

        ```python
        import pulumi
        import pulumi_rediscloud as rediscloud

        card = rediscloud.get_payment_method(card_type="Visa")
        subscription_resource = rediscloud.ActiveActiveSubscription("subscription-resource",
            payment_method_id=card.id,
            cloud_provider="AWS",
            creation_plan=rediscloud.ActiveActiveSubscriptionCreationPlanArgs(
                memory_limit_in_gb=1,
                quantity=1,
                regions=[
                    rediscloud.ActiveActiveSubscriptionCreationPlanRegionArgs(
                        region="us-east-1",
                        networking_deployment_cidr="192.168.0.0/24",
                        write_operations_per_second=1000,
                        read_operations_per_second=1000,
                    ),
                    rediscloud.ActiveActiveSubscriptionCreationPlanRegionArgs(
                        region="us-east-2",
                        networking_deployment_cidr="10.0.1.0/24",
                        write_operations_per_second=1000,
                        read_operations_per_second=1000,
                    ),
                ],
            ))
        ```

        ## Import

        `rediscloud_active_active_subscription` can be imported using the ID of the subscription, e.g.

        ```sh
         $ pulumi import rediscloud:index/activeActiveSubscription:ActiveActiveSubscription subscription-resource 12345678
        ```

        :param str resource_name: The name of the resource.
        :param ActiveActiveSubscriptionArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(ActiveActiveSubscriptionArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 cloud_provider: Optional[pulumi.Input[str]] = None,
                 creation_plan: Optional[pulumi.Input[pulumi.InputType['ActiveActiveSubscriptionCreationPlanArgs']]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 payment_method: Optional[pulumi.Input[str]] = None,
                 payment_method_id: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = ActiveActiveSubscriptionArgs.__new__(ActiveActiveSubscriptionArgs)

            __props__.__dict__["cloud_provider"] = cloud_provider
            __props__.__dict__["creation_plan"] = creation_plan
            __props__.__dict__["name"] = name
            __props__.__dict__["payment_method"] = payment_method
            __props__.__dict__["payment_method_id"] = payment_method_id
        super(ActiveActiveSubscription, __self__).__init__(
            'rediscloud:index/activeActiveSubscription:ActiveActiveSubscription',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            cloud_provider: Optional[pulumi.Input[str]] = None,
            creation_plan: Optional[pulumi.Input[pulumi.InputType['ActiveActiveSubscriptionCreationPlanArgs']]] = None,
            name: Optional[pulumi.Input[str]] = None,
            payment_method: Optional[pulumi.Input[str]] = None,
            payment_method_id: Optional[pulumi.Input[str]] = None) -> 'ActiveActiveSubscription':
        """
        Get an existing ActiveActiveSubscription resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] cloud_provider: The cloud provider to use with the subscription, (either `AWS` or `GCP`). Default: ‘AWS’
        :param pulumi.Input[pulumi.InputType['ActiveActiveSubscriptionCreationPlanArgs']] creation_plan: A creation plan object, documented below
        :param pulumi.Input[str] name: A meaningful name to identify the subscription
        :param pulumi.Input[str] payment_method: The payment method for the requested subscription, (either `credit-card` or `marketplace`). If `credit-card` is specified, `payment_method_id` must be defined. Default: 'credit-card'
        :param pulumi.Input[str] payment_method_id: A valid payment method pre-defined in the current account. This value is __Optional__ for AWS/GCP Marketplace accounts, but __Required__ for all other account types
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _ActiveActiveSubscriptionState.__new__(_ActiveActiveSubscriptionState)

        __props__.__dict__["cloud_provider"] = cloud_provider
        __props__.__dict__["creation_plan"] = creation_plan
        __props__.__dict__["name"] = name
        __props__.__dict__["payment_method"] = payment_method
        __props__.__dict__["payment_method_id"] = payment_method_id
        return ActiveActiveSubscription(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="cloudProvider")
    def cloud_provider(self) -> pulumi.Output[Optional[str]]:
        """
        The cloud provider to use with the subscription, (either `AWS` or `GCP`). Default: ‘AWS’
        """
        return pulumi.get(self, "cloud_provider")

    @property
    @pulumi.getter(name="creationPlan")
    def creation_plan(self) -> pulumi.Output[Optional['outputs.ActiveActiveSubscriptionCreationPlan']]:
        """
        A creation plan object, documented below
        """
        return pulumi.get(self, "creation_plan")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[str]:
        """
        A meaningful name to identify the subscription
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="paymentMethod")
    def payment_method(self) -> pulumi.Output[Optional[str]]:
        """
        The payment method for the requested subscription, (either `credit-card` or `marketplace`). If `credit-card` is specified, `payment_method_id` must be defined. Default: 'credit-card'
        """
        return pulumi.get(self, "payment_method")

    @property
    @pulumi.getter(name="paymentMethodId")
    def payment_method_id(self) -> pulumi.Output[str]:
        """
        A valid payment method pre-defined in the current account. This value is __Optional__ for AWS/GCP Marketplace accounts, but __Required__ for all other account types
        """
        return pulumi.get(self, "payment_method_id")

