# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities
from . import outputs

__all__ = [
    'GetDatabaseModulesResult',
    'AwaitableGetDatabaseModulesResult',
    'get_database_modules',
]

@pulumi.output_type
class GetDatabaseModulesResult:
    """
    A collection of values returned by getDatabaseModules.
    """
    def __init__(__self__, id=None, modules=None):
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if modules and not isinstance(modules, list):
            raise TypeError("Expected argument 'modules' to be a list")
        pulumi.set(__self__, "modules", modules)

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def modules(self) -> Sequence['outputs.GetDatabaseModulesModuleResult']:
        """
        A list of database modules.
        """
        return pulumi.get(self, "modules")


class AwaitableGetDatabaseModulesResult(GetDatabaseModulesResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetDatabaseModulesResult(
            id=self.id,
            modules=self.modules)


def get_database_modules(opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetDatabaseModulesResult:
    """
    The database modules data source allows access to a list of supported [Redis Enterprise Cloud modules](https://redislabs.com/redis-enterprise/modules).\\
    Each module represents an enrichment that can be applied to a Redis database.

    ## Example Usage

    The following example returns a list of all modules available within your Redis Enterprise Cloud account.

    ```python
    import pulumi
    import pulumi_rediscloud as rediscloud

    example = rediscloud.get_database_modules()
    pulumi.export("rediscloudDatabaseModules", example.modules)
    ```
    """
    __args__ = dict()
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('rediscloud:index/getDatabaseModules:getDatabaseModules', __args__, opts=opts, typ=GetDatabaseModulesResult).value

    return AwaitableGetDatabaseModulesResult(
        id=__ret__.id,
        modules=__ret__.modules)
