# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities

__all__ = [
    'GetPaymentMethodResult',
    'AwaitableGetPaymentMethodResult',
    'get_payment_method',
    'get_payment_method_output',
]

@pulumi.output_type
class GetPaymentMethodResult:
    """
    A collection of values returned by getPaymentMethod.
    """
    def __init__(__self__, card_type=None, exclude_expired=None, id=None, last_four_numbers=None):
        if card_type and not isinstance(card_type, str):
            raise TypeError("Expected argument 'card_type' to be a str")
        pulumi.set(__self__, "card_type", card_type)
        if exclude_expired and not isinstance(exclude_expired, bool):
            raise TypeError("Expected argument 'exclude_expired' to be a bool")
        pulumi.set(__self__, "exclude_expired", exclude_expired)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if last_four_numbers and not isinstance(last_four_numbers, str):
            raise TypeError("Expected argument 'last_four_numbers' to be a str")
        pulumi.set(__self__, "last_four_numbers", last_four_numbers)

    @property
    @pulumi.getter(name="cardType")
    def card_type(self) -> str:
        return pulumi.get(self, "card_type")

    @property
    @pulumi.getter(name="excludeExpired")
    def exclude_expired(self) -> Optional[bool]:
        return pulumi.get(self, "exclude_expired")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="lastFourNumbers")
    def last_four_numbers(self) -> str:
        return pulumi.get(self, "last_four_numbers")


class AwaitableGetPaymentMethodResult(GetPaymentMethodResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetPaymentMethodResult(
            card_type=self.card_type,
            exclude_expired=self.exclude_expired,
            id=self.id,
            last_four_numbers=self.last_four_numbers)


def get_payment_method(card_type: Optional[str] = None,
                       exclude_expired: Optional[bool] = None,
                       last_four_numbers: Optional[str] = None,
                       opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetPaymentMethodResult:
    """
    The Payment Method data source allows access to the ID of a Payment Method configured against your Redis Enterprise Cloud account. This ID can be used when creating Subscription resources.


    :param str card_type: Type of card that the payment method should be, such as `Visa`.
    :param bool exclude_expired: Whether to exclude any expired cards or not. Default is `true`.
    :param str last_four_numbers: Last four numbers of the card of the payment method.
    """
    __args__ = dict()
    __args__['cardType'] = card_type
    __args__['excludeExpired'] = exclude_expired
    __args__['lastFourNumbers'] = last_four_numbers
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('rediscloud:index/getPaymentMethod:getPaymentMethod', __args__, opts=opts, typ=GetPaymentMethodResult).value

    return AwaitableGetPaymentMethodResult(
        card_type=__ret__.card_type,
        exclude_expired=__ret__.exclude_expired,
        id=__ret__.id,
        last_four_numbers=__ret__.last_four_numbers)


@_utilities.lift_output_func(get_payment_method)
def get_payment_method_output(card_type: Optional[pulumi.Input[Optional[str]]] = None,
                              exclude_expired: Optional[pulumi.Input[Optional[bool]]] = None,
                              last_four_numbers: Optional[pulumi.Input[Optional[str]]] = None,
                              opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetPaymentMethodResult]:
    """
    The Payment Method data source allows access to the ID of a Payment Method configured against your Redis Enterprise Cloud account. This ID can be used when creating Subscription resources.


    :param str card_type: Type of card that the payment method should be, such as `Visa`.
    :param bool exclude_expired: Whether to exclude any expired cards or not. Default is `true`.
    :param str last_four_numbers: Last four numbers of the card of the payment method.
    """
    ...
