# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities

__all__ = ['SubscriptionPeeringArgs', 'SubscriptionPeering']

@pulumi.input_type
class SubscriptionPeeringArgs:
    def __init__(__self__, *,
                 subscription_id: pulumi.Input[str],
                 aws_account_id: Optional[pulumi.Input[str]] = None,
                 gcp_network_name: Optional[pulumi.Input[str]] = None,
                 gcp_project_id: Optional[pulumi.Input[str]] = None,
                 provider_name: Optional[pulumi.Input[str]] = None,
                 region: Optional[pulumi.Input[str]] = None,
                 vpc_cidr: Optional[pulumi.Input[str]] = None,
                 vpc_id: Optional[pulumi.Input[str]] = None):
        """
        The set of arguments for constructing a SubscriptionPeering resource.
        :param pulumi.Input[str] subscription_id: A valid subscription predefined in the current account
        :param pulumi.Input[str] aws_account_id: AWS account ID that the VPC to be peered lives in
        :param pulumi.Input[str] gcp_network_name: The name of the network to be peered
        :param pulumi.Input[str] gcp_project_id: GCP project ID that the VPC to be peered lives in
        :param pulumi.Input[str] provider_name: The cloud provider to use with the vpc peering, (either `AWS` or `GCP`). Default: ‘AWS’
        :param pulumi.Input[str] region: AWS Region that the VPC to be peered lives in
        :param pulumi.Input[str] vpc_cidr: CIDR range of the VPC to be peered
        :param pulumi.Input[str] vpc_id: Identifier of the VPC to be peered
        """
        pulumi.set(__self__, "subscription_id", subscription_id)
        if aws_account_id is not None:
            pulumi.set(__self__, "aws_account_id", aws_account_id)
        if gcp_network_name is not None:
            pulumi.set(__self__, "gcp_network_name", gcp_network_name)
        if gcp_project_id is not None:
            pulumi.set(__self__, "gcp_project_id", gcp_project_id)
        if provider_name is not None:
            pulumi.set(__self__, "provider_name", provider_name)
        if region is not None:
            pulumi.set(__self__, "region", region)
        if vpc_cidr is not None:
            pulumi.set(__self__, "vpc_cidr", vpc_cidr)
        if vpc_id is not None:
            pulumi.set(__self__, "vpc_id", vpc_id)

    @property
    @pulumi.getter(name="subscriptionId")
    def subscription_id(self) -> pulumi.Input[str]:
        """
        A valid subscription predefined in the current account
        """
        return pulumi.get(self, "subscription_id")

    @subscription_id.setter
    def subscription_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "subscription_id", value)

    @property
    @pulumi.getter(name="awsAccountId")
    def aws_account_id(self) -> Optional[pulumi.Input[str]]:
        """
        AWS account ID that the VPC to be peered lives in
        """
        return pulumi.get(self, "aws_account_id")

    @aws_account_id.setter
    def aws_account_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "aws_account_id", value)

    @property
    @pulumi.getter(name="gcpNetworkName")
    def gcp_network_name(self) -> Optional[pulumi.Input[str]]:
        """
        The name of the network to be peered
        """
        return pulumi.get(self, "gcp_network_name")

    @gcp_network_name.setter
    def gcp_network_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "gcp_network_name", value)

    @property
    @pulumi.getter(name="gcpProjectId")
    def gcp_project_id(self) -> Optional[pulumi.Input[str]]:
        """
        GCP project ID that the VPC to be peered lives in
        """
        return pulumi.get(self, "gcp_project_id")

    @gcp_project_id.setter
    def gcp_project_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "gcp_project_id", value)

    @property
    @pulumi.getter(name="providerName")
    def provider_name(self) -> Optional[pulumi.Input[str]]:
        """
        The cloud provider to use with the vpc peering, (either `AWS` or `GCP`). Default: ‘AWS’
        """
        return pulumi.get(self, "provider_name")

    @provider_name.setter
    def provider_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "provider_name", value)

    @property
    @pulumi.getter
    def region(self) -> Optional[pulumi.Input[str]]:
        """
        AWS Region that the VPC to be peered lives in
        """
        return pulumi.get(self, "region")

    @region.setter
    def region(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "region", value)

    @property
    @pulumi.getter(name="vpcCidr")
    def vpc_cidr(self) -> Optional[pulumi.Input[str]]:
        """
        CIDR range of the VPC to be peered
        """
        return pulumi.get(self, "vpc_cidr")

    @vpc_cidr.setter
    def vpc_cidr(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "vpc_cidr", value)

    @property
    @pulumi.getter(name="vpcId")
    def vpc_id(self) -> Optional[pulumi.Input[str]]:
        """
        Identifier of the VPC to be peered
        """
        return pulumi.get(self, "vpc_id")

    @vpc_id.setter
    def vpc_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "vpc_id", value)


@pulumi.input_type
class _SubscriptionPeeringState:
    def __init__(__self__, *,
                 aws_account_id: Optional[pulumi.Input[str]] = None,
                 aws_peering_id: Optional[pulumi.Input[str]] = None,
                 gcp_network_name: Optional[pulumi.Input[str]] = None,
                 gcp_peering_id: Optional[pulumi.Input[str]] = None,
                 gcp_project_id: Optional[pulumi.Input[str]] = None,
                 gcp_redis_network_name: Optional[pulumi.Input[str]] = None,
                 gcp_redis_project_id: Optional[pulumi.Input[str]] = None,
                 provider_name: Optional[pulumi.Input[str]] = None,
                 region: Optional[pulumi.Input[str]] = None,
                 status: Optional[pulumi.Input[str]] = None,
                 subscription_id: Optional[pulumi.Input[str]] = None,
                 vpc_cidr: Optional[pulumi.Input[str]] = None,
                 vpc_id: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering SubscriptionPeering resources.
        :param pulumi.Input[str] aws_account_id: AWS account ID that the VPC to be peered lives in
        :param pulumi.Input[str] aws_peering_id: Identifier of the AWS cloud peering
        :param pulumi.Input[str] gcp_network_name: The name of the network to be peered
        :param pulumi.Input[str] gcp_peering_id: Identifier of the cloud peering
        :param pulumi.Input[str] gcp_project_id: GCP project ID that the VPC to be peered lives in
        :param pulumi.Input[str] gcp_redis_network_name: The name of the Redis Enterprise Cloud network to be peered
        :param pulumi.Input[str] gcp_redis_project_id: Identifier of the Redis Enterprise Cloud GCP project to be peered
        :param pulumi.Input[str] provider_name: The cloud provider to use with the vpc peering, (either `AWS` or `GCP`). Default: ‘AWS’
        :param pulumi.Input[str] region: AWS Region that the VPC to be peered lives in
        :param pulumi.Input[str] status: is set to the current status of the peering - `initiating-request`, `pending-acceptance`, `active`, `inactive` or `failed`.
        :param pulumi.Input[str] subscription_id: A valid subscription predefined in the current account
        :param pulumi.Input[str] vpc_cidr: CIDR range of the VPC to be peered
        :param pulumi.Input[str] vpc_id: Identifier of the VPC to be peered
        """
        if aws_account_id is not None:
            pulumi.set(__self__, "aws_account_id", aws_account_id)
        if aws_peering_id is not None:
            pulumi.set(__self__, "aws_peering_id", aws_peering_id)
        if gcp_network_name is not None:
            pulumi.set(__self__, "gcp_network_name", gcp_network_name)
        if gcp_peering_id is not None:
            pulumi.set(__self__, "gcp_peering_id", gcp_peering_id)
        if gcp_project_id is not None:
            pulumi.set(__self__, "gcp_project_id", gcp_project_id)
        if gcp_redis_network_name is not None:
            pulumi.set(__self__, "gcp_redis_network_name", gcp_redis_network_name)
        if gcp_redis_project_id is not None:
            pulumi.set(__self__, "gcp_redis_project_id", gcp_redis_project_id)
        if provider_name is not None:
            pulumi.set(__self__, "provider_name", provider_name)
        if region is not None:
            pulumi.set(__self__, "region", region)
        if status is not None:
            pulumi.set(__self__, "status", status)
        if subscription_id is not None:
            pulumi.set(__self__, "subscription_id", subscription_id)
        if vpc_cidr is not None:
            pulumi.set(__self__, "vpc_cidr", vpc_cidr)
        if vpc_id is not None:
            pulumi.set(__self__, "vpc_id", vpc_id)

    @property
    @pulumi.getter(name="awsAccountId")
    def aws_account_id(self) -> Optional[pulumi.Input[str]]:
        """
        AWS account ID that the VPC to be peered lives in
        """
        return pulumi.get(self, "aws_account_id")

    @aws_account_id.setter
    def aws_account_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "aws_account_id", value)

    @property
    @pulumi.getter(name="awsPeeringId")
    def aws_peering_id(self) -> Optional[pulumi.Input[str]]:
        """
        Identifier of the AWS cloud peering
        """
        return pulumi.get(self, "aws_peering_id")

    @aws_peering_id.setter
    def aws_peering_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "aws_peering_id", value)

    @property
    @pulumi.getter(name="gcpNetworkName")
    def gcp_network_name(self) -> Optional[pulumi.Input[str]]:
        """
        The name of the network to be peered
        """
        return pulumi.get(self, "gcp_network_name")

    @gcp_network_name.setter
    def gcp_network_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "gcp_network_name", value)

    @property
    @pulumi.getter(name="gcpPeeringId")
    def gcp_peering_id(self) -> Optional[pulumi.Input[str]]:
        """
        Identifier of the cloud peering
        """
        return pulumi.get(self, "gcp_peering_id")

    @gcp_peering_id.setter
    def gcp_peering_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "gcp_peering_id", value)

    @property
    @pulumi.getter(name="gcpProjectId")
    def gcp_project_id(self) -> Optional[pulumi.Input[str]]:
        """
        GCP project ID that the VPC to be peered lives in
        """
        return pulumi.get(self, "gcp_project_id")

    @gcp_project_id.setter
    def gcp_project_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "gcp_project_id", value)

    @property
    @pulumi.getter(name="gcpRedisNetworkName")
    def gcp_redis_network_name(self) -> Optional[pulumi.Input[str]]:
        """
        The name of the Redis Enterprise Cloud network to be peered
        """
        return pulumi.get(self, "gcp_redis_network_name")

    @gcp_redis_network_name.setter
    def gcp_redis_network_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "gcp_redis_network_name", value)

    @property
    @pulumi.getter(name="gcpRedisProjectId")
    def gcp_redis_project_id(self) -> Optional[pulumi.Input[str]]:
        """
        Identifier of the Redis Enterprise Cloud GCP project to be peered
        """
        return pulumi.get(self, "gcp_redis_project_id")

    @gcp_redis_project_id.setter
    def gcp_redis_project_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "gcp_redis_project_id", value)

    @property
    @pulumi.getter(name="providerName")
    def provider_name(self) -> Optional[pulumi.Input[str]]:
        """
        The cloud provider to use with the vpc peering, (either `AWS` or `GCP`). Default: ‘AWS’
        """
        return pulumi.get(self, "provider_name")

    @provider_name.setter
    def provider_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "provider_name", value)

    @property
    @pulumi.getter
    def region(self) -> Optional[pulumi.Input[str]]:
        """
        AWS Region that the VPC to be peered lives in
        """
        return pulumi.get(self, "region")

    @region.setter
    def region(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "region", value)

    @property
    @pulumi.getter
    def status(self) -> Optional[pulumi.Input[str]]:
        """
        is set to the current status of the peering - `initiating-request`, `pending-acceptance`, `active`, `inactive` or `failed`.
        """
        return pulumi.get(self, "status")

    @status.setter
    def status(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "status", value)

    @property
    @pulumi.getter(name="subscriptionId")
    def subscription_id(self) -> Optional[pulumi.Input[str]]:
        """
        A valid subscription predefined in the current account
        """
        return pulumi.get(self, "subscription_id")

    @subscription_id.setter
    def subscription_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "subscription_id", value)

    @property
    @pulumi.getter(name="vpcCidr")
    def vpc_cidr(self) -> Optional[pulumi.Input[str]]:
        """
        CIDR range of the VPC to be peered
        """
        return pulumi.get(self, "vpc_cidr")

    @vpc_cidr.setter
    def vpc_cidr(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "vpc_cidr", value)

    @property
    @pulumi.getter(name="vpcId")
    def vpc_id(self) -> Optional[pulumi.Input[str]]:
        """
        Identifier of the VPC to be peered
        """
        return pulumi.get(self, "vpc_id")

    @vpc_id.setter
    def vpc_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "vpc_id", value)


class SubscriptionPeering(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 aws_account_id: Optional[pulumi.Input[str]] = None,
                 gcp_network_name: Optional[pulumi.Input[str]] = None,
                 gcp_project_id: Optional[pulumi.Input[str]] = None,
                 provider_name: Optional[pulumi.Input[str]] = None,
                 region: Optional[pulumi.Input[str]] = None,
                 subscription_id: Optional[pulumi.Input[str]] = None,
                 vpc_cidr: Optional[pulumi.Input[str]] = None,
                 vpc_id: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Creates an AWS or GCP VPC peering for an existing Redis Enterprise Cloud Subscription, allowing access to your subscription databases as if they were on the same network.

        For AWS, peering should be accepted by the other side.
        For GCP, the opposite peering request should be submitted.

        ## Example Usage
        ### AWS

        The following example shows how a subscription can be peered with a AWS VPC using the rediscloud and google providers.

        ```python
        import pulumi
        import pulumi_aws as aws
        import pulumi_rediscloud as rediscloud

        example_subscription = rediscloud.Subscription("exampleSubscription")
        # ...
        example_subscription_peering = rediscloud.SubscriptionPeering("exampleSubscriptionPeering",
            subscription_id=example_subscription.id,
            region="eu-west-1",
            aws_account_id="123456789012",
            vpc_id="vpc-01234567890",
            vpc_cidr="10.0.0.0/8")
        example_peering = aws.ec2.VpcPeeringConnectionAccepter("example-peering",
            vpc_peering_connection_id=example_subscription_peering.aws_peering_id,
            auto_accept=True)
        ```
        ### GCP

        The following example shows how a subscription can be peered with a GCP project network using the rediscloud and google providers.
        The example HCL locates the network details and creates/accepts the vpc peering connection through the Google provider.

        ```python
        import pulumi
        import pulumi_gcp as gcp
        import pulumi_rediscloud as rediscloud

        example = rediscloud.Subscription("example")
        # ...
        network = gcp.compute.get_network(project="my-gcp-project",
            name="my-gcp-vpc")
        example_peering_subscription_peering = rediscloud.SubscriptionPeering("example-peeringSubscriptionPeering",
            subscription_id=example.id,
            provider_name="GCP",
            gcp_project_id=network.project,
            gcp_network_name=network.name)
        example_peering_network_peering = gcp.compute.NetworkPeering("example-peeringNetworkPeering",
            network=network.self_link,
            peer_network=f"https://www.googleapis.com/compute/v1/projects/{rediscloud_subscription_peering['example']['gcp_redis_project_id']}/global/networks/{rediscloud_subscription_peering['example']['gcp_redis_network_name']}")
        ```

        ## Import

        `rediscloud_subscription_peering` can be imported using the ID of the subscription and the ID of the peering connection, e.g.

        ```sh
         $ pulumi import rediscloud:index/subscriptionPeering:SubscriptionPeering example 12345678/1234
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] aws_account_id: AWS account ID that the VPC to be peered lives in
        :param pulumi.Input[str] gcp_network_name: The name of the network to be peered
        :param pulumi.Input[str] gcp_project_id: GCP project ID that the VPC to be peered lives in
        :param pulumi.Input[str] provider_name: The cloud provider to use with the vpc peering, (either `AWS` or `GCP`). Default: ‘AWS’
        :param pulumi.Input[str] region: AWS Region that the VPC to be peered lives in
        :param pulumi.Input[str] subscription_id: A valid subscription predefined in the current account
        :param pulumi.Input[str] vpc_cidr: CIDR range of the VPC to be peered
        :param pulumi.Input[str] vpc_id: Identifier of the VPC to be peered
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: SubscriptionPeeringArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Creates an AWS or GCP VPC peering for an existing Redis Enterprise Cloud Subscription, allowing access to your subscription databases as if they were on the same network.

        For AWS, peering should be accepted by the other side.
        For GCP, the opposite peering request should be submitted.

        ## Example Usage
        ### AWS

        The following example shows how a subscription can be peered with a AWS VPC using the rediscloud and google providers.

        ```python
        import pulumi
        import pulumi_aws as aws
        import pulumi_rediscloud as rediscloud

        example_subscription = rediscloud.Subscription("exampleSubscription")
        # ...
        example_subscription_peering = rediscloud.SubscriptionPeering("exampleSubscriptionPeering",
            subscription_id=example_subscription.id,
            region="eu-west-1",
            aws_account_id="123456789012",
            vpc_id="vpc-01234567890",
            vpc_cidr="10.0.0.0/8")
        example_peering = aws.ec2.VpcPeeringConnectionAccepter("example-peering",
            vpc_peering_connection_id=example_subscription_peering.aws_peering_id,
            auto_accept=True)
        ```
        ### GCP

        The following example shows how a subscription can be peered with a GCP project network using the rediscloud and google providers.
        The example HCL locates the network details and creates/accepts the vpc peering connection through the Google provider.

        ```python
        import pulumi
        import pulumi_gcp as gcp
        import pulumi_rediscloud as rediscloud

        example = rediscloud.Subscription("example")
        # ...
        network = gcp.compute.get_network(project="my-gcp-project",
            name="my-gcp-vpc")
        example_peering_subscription_peering = rediscloud.SubscriptionPeering("example-peeringSubscriptionPeering",
            subscription_id=example.id,
            provider_name="GCP",
            gcp_project_id=network.project,
            gcp_network_name=network.name)
        example_peering_network_peering = gcp.compute.NetworkPeering("example-peeringNetworkPeering",
            network=network.self_link,
            peer_network=f"https://www.googleapis.com/compute/v1/projects/{rediscloud_subscription_peering['example']['gcp_redis_project_id']}/global/networks/{rediscloud_subscription_peering['example']['gcp_redis_network_name']}")
        ```

        ## Import

        `rediscloud_subscription_peering` can be imported using the ID of the subscription and the ID of the peering connection, e.g.

        ```sh
         $ pulumi import rediscloud:index/subscriptionPeering:SubscriptionPeering example 12345678/1234
        ```

        :param str resource_name: The name of the resource.
        :param SubscriptionPeeringArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(SubscriptionPeeringArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 aws_account_id: Optional[pulumi.Input[str]] = None,
                 gcp_network_name: Optional[pulumi.Input[str]] = None,
                 gcp_project_id: Optional[pulumi.Input[str]] = None,
                 provider_name: Optional[pulumi.Input[str]] = None,
                 region: Optional[pulumi.Input[str]] = None,
                 subscription_id: Optional[pulumi.Input[str]] = None,
                 vpc_cidr: Optional[pulumi.Input[str]] = None,
                 vpc_id: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = SubscriptionPeeringArgs.__new__(SubscriptionPeeringArgs)

            __props__.__dict__["aws_account_id"] = aws_account_id
            __props__.__dict__["gcp_network_name"] = gcp_network_name
            __props__.__dict__["gcp_project_id"] = gcp_project_id
            __props__.__dict__["provider_name"] = provider_name
            __props__.__dict__["region"] = region
            if subscription_id is None and not opts.urn:
                raise TypeError("Missing required property 'subscription_id'")
            __props__.__dict__["subscription_id"] = subscription_id
            __props__.__dict__["vpc_cidr"] = vpc_cidr
            __props__.__dict__["vpc_id"] = vpc_id
            __props__.__dict__["aws_peering_id"] = None
            __props__.__dict__["gcp_peering_id"] = None
            __props__.__dict__["gcp_redis_network_name"] = None
            __props__.__dict__["gcp_redis_project_id"] = None
            __props__.__dict__["status"] = None
        super(SubscriptionPeering, __self__).__init__(
            'rediscloud:index/subscriptionPeering:SubscriptionPeering',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            aws_account_id: Optional[pulumi.Input[str]] = None,
            aws_peering_id: Optional[pulumi.Input[str]] = None,
            gcp_network_name: Optional[pulumi.Input[str]] = None,
            gcp_peering_id: Optional[pulumi.Input[str]] = None,
            gcp_project_id: Optional[pulumi.Input[str]] = None,
            gcp_redis_network_name: Optional[pulumi.Input[str]] = None,
            gcp_redis_project_id: Optional[pulumi.Input[str]] = None,
            provider_name: Optional[pulumi.Input[str]] = None,
            region: Optional[pulumi.Input[str]] = None,
            status: Optional[pulumi.Input[str]] = None,
            subscription_id: Optional[pulumi.Input[str]] = None,
            vpc_cidr: Optional[pulumi.Input[str]] = None,
            vpc_id: Optional[pulumi.Input[str]] = None) -> 'SubscriptionPeering':
        """
        Get an existing SubscriptionPeering resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] aws_account_id: AWS account ID that the VPC to be peered lives in
        :param pulumi.Input[str] aws_peering_id: Identifier of the AWS cloud peering
        :param pulumi.Input[str] gcp_network_name: The name of the network to be peered
        :param pulumi.Input[str] gcp_peering_id: Identifier of the cloud peering
        :param pulumi.Input[str] gcp_project_id: GCP project ID that the VPC to be peered lives in
        :param pulumi.Input[str] gcp_redis_network_name: The name of the Redis Enterprise Cloud network to be peered
        :param pulumi.Input[str] gcp_redis_project_id: Identifier of the Redis Enterprise Cloud GCP project to be peered
        :param pulumi.Input[str] provider_name: The cloud provider to use with the vpc peering, (either `AWS` or `GCP`). Default: ‘AWS’
        :param pulumi.Input[str] region: AWS Region that the VPC to be peered lives in
        :param pulumi.Input[str] status: is set to the current status of the peering - `initiating-request`, `pending-acceptance`, `active`, `inactive` or `failed`.
        :param pulumi.Input[str] subscription_id: A valid subscription predefined in the current account
        :param pulumi.Input[str] vpc_cidr: CIDR range of the VPC to be peered
        :param pulumi.Input[str] vpc_id: Identifier of the VPC to be peered
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _SubscriptionPeeringState.__new__(_SubscriptionPeeringState)

        __props__.__dict__["aws_account_id"] = aws_account_id
        __props__.__dict__["aws_peering_id"] = aws_peering_id
        __props__.__dict__["gcp_network_name"] = gcp_network_name
        __props__.__dict__["gcp_peering_id"] = gcp_peering_id
        __props__.__dict__["gcp_project_id"] = gcp_project_id
        __props__.__dict__["gcp_redis_network_name"] = gcp_redis_network_name
        __props__.__dict__["gcp_redis_project_id"] = gcp_redis_project_id
        __props__.__dict__["provider_name"] = provider_name
        __props__.__dict__["region"] = region
        __props__.__dict__["status"] = status
        __props__.__dict__["subscription_id"] = subscription_id
        __props__.__dict__["vpc_cidr"] = vpc_cidr
        __props__.__dict__["vpc_id"] = vpc_id
        return SubscriptionPeering(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="awsAccountId")
    def aws_account_id(self) -> pulumi.Output[str]:
        """
        AWS account ID that the VPC to be peered lives in
        """
        return pulumi.get(self, "aws_account_id")

    @property
    @pulumi.getter(name="awsPeeringId")
    def aws_peering_id(self) -> pulumi.Output[str]:
        """
        Identifier of the AWS cloud peering
        """
        return pulumi.get(self, "aws_peering_id")

    @property
    @pulumi.getter(name="gcpNetworkName")
    def gcp_network_name(self) -> pulumi.Output[str]:
        """
        The name of the network to be peered
        """
        return pulumi.get(self, "gcp_network_name")

    @property
    @pulumi.getter(name="gcpPeeringId")
    def gcp_peering_id(self) -> pulumi.Output[str]:
        """
        Identifier of the cloud peering
        """
        return pulumi.get(self, "gcp_peering_id")

    @property
    @pulumi.getter(name="gcpProjectId")
    def gcp_project_id(self) -> pulumi.Output[str]:
        """
        GCP project ID that the VPC to be peered lives in
        """
        return pulumi.get(self, "gcp_project_id")

    @property
    @pulumi.getter(name="gcpRedisNetworkName")
    def gcp_redis_network_name(self) -> pulumi.Output[str]:
        """
        The name of the Redis Enterprise Cloud network to be peered
        """
        return pulumi.get(self, "gcp_redis_network_name")

    @property
    @pulumi.getter(name="gcpRedisProjectId")
    def gcp_redis_project_id(self) -> pulumi.Output[str]:
        """
        Identifier of the Redis Enterprise Cloud GCP project to be peered
        """
        return pulumi.get(self, "gcp_redis_project_id")

    @property
    @pulumi.getter(name="providerName")
    def provider_name(self) -> pulumi.Output[Optional[str]]:
        """
        The cloud provider to use with the vpc peering, (either `AWS` or `GCP`). Default: ‘AWS’
        """
        return pulumi.get(self, "provider_name")

    @property
    @pulumi.getter
    def region(self) -> pulumi.Output[str]:
        """
        AWS Region that the VPC to be peered lives in
        """
        return pulumi.get(self, "region")

    @property
    @pulumi.getter
    def status(self) -> pulumi.Output[str]:
        """
        is set to the current status of the peering - `initiating-request`, `pending-acceptance`, `active`, `inactive` or `failed`.
        """
        return pulumi.get(self, "status")

    @property
    @pulumi.getter(name="subscriptionId")
    def subscription_id(self) -> pulumi.Output[str]:
        """
        A valid subscription predefined in the current account
        """
        return pulumi.get(self, "subscription_id")

    @property
    @pulumi.getter(name="vpcCidr")
    def vpc_cidr(self) -> pulumi.Output[str]:
        """
        CIDR range of the VPC to be peered
        """
        return pulumi.get(self, "vpc_cidr")

    @property
    @pulumi.getter(name="vpcId")
    def vpc_id(self) -> pulumi.Output[str]:
        """
        Identifier of the VPC to be peered
        """
        return pulumi.get(self, "vpc_id")

